/*
 * gc global variable provides access to GUI Composer infrastructure components and project information.
 * For more information, please see the Working with Javascript guide in the online help.
 */
var gc = gc || {};
gc.services = gc.services || {};

//Initialize Global Variables

selectedEVM = 0; 
adcrange = [0, 0, 0, 0];
current_lsb = [1, 1, 1, 1];

preventCalculations = false;

data = [
    {
        sw0: 0,
        sw1: 0,
        adcrange: 0,
        rshunt: ' ',
        maxcurrent: ' ',
        currentlsb: ' ',
        shuntcal: 4096,
        truelsb: ' ',
        truecurrent: ' ',
        requiredrange: ' '
    },
    {
        sw0: 0,
        sw1: 0,
        adcrange: 0,
        rshunt: ' ',
        maxcurrent: ' ',
        currentlsb: ' ',
        shuntcal: 4096,
        truelsb: ' ',
        truecurrent: ' ',
        requiredrange: ' '
    },
    {
        sw0: 0,
        sw1: 0,
        adcrange: 0,
        rshunt: ' ',
        maxcurrent: ' ',
        currentlsb: ' ',
        shuntcal: 4096,
        truelsb: ' ',
        truecurrent: ' ',
        requiredrange: ' '
    },
    {
        sw0: 0,
        sw1: 0,
        adcrange: 0,
        rshunt: ' ',
        maxcurrent: ' ',
        currentlsb: ' ',
        shuntcal: 4096,
        truelsb: ' ',
        truecurrent: ' ',
        requiredrange: ' '
    }
];

/*
*  Boilerplate code for creating computed data bindings
*/
document.addEventListener('gc-databind-ready', function() 
{
    /* 
	*   Add custom computed value databindings here, using the following method:
	*
    *   function gc.databind.registry.bind(targetBinding, modelBinding, [getter], [setter]);
	*
	*   param targetBinding - single binding string or expression, or array of binding strings for multi-way binding.
	*   param modelBinding - single binding string or expression, or array of binding strings for multi-way binding.
	*   param getter - (optional) - custom getter function for computing the targetBinding value(s) based on modelBinding value(s).
	*   param setter - (optional) - custom setter function for computing the modelBinding value(s) based on targetBinding value(s).
    */
	
	// For example, a simple computed values based on simple expression
	// gc.databind.registry.bind('widget.id.propertyName', "targetVariable == 1 ? 'binding is one' : 'binding is not one'");
	
	// Or a custom two-way binding with custome getter and setter functions.  (setter is optional)  (getter only indicates one-way binding)
	// gc.databind.registry.bind('widget.id.propertyName', "targetVariable", function(value) { return value*5/9 + 32; }, function(value) { (return value-32)*9/5; });
	
	// Event 1 to n bindings
	/* 
    gc.databind.registry.bind('widget.date.value', 
        // dependant bindings needed in order to compute the date, in name/value pairs.
        {
            weekday: 'widget.dayOfWeek.selectedText',
            day: 'widget.dayOfMonth.value',
            month: 'widget.month.selectedText',
            year: 'widget.year.value'
        }, 
        // getter for date computation
        function(values) 
        {
            // compute and return the string value to bind to the widget with id 'date'
            return values.weekday + ', ' + values.month + ' ' + values.day + ', ' + values.year;
        }
    ); 
	*/


	let selectedIndex = gc.databind.registry.getBinding('widget.ti_widget_droplist_selectedEVM.selectedIndex');
    
    gc.databind.registry.bind( 
        { 
            sw0: 'widget.ti_widget_droplist_config_SW0.selectedValue',
            sw1: 'widget.ti_widget_droplist_config_SW1.selectedValue',
            adcrange: 'widget.ti_widget_droplist_config_adcrange.selectedValue',
            rshunt: 'widget.ti_widget_textbox_rshunt.value',
            maxcurrent: 'widget.ti_widget_textbox_current.value',
            currentlsb: 'widget.ti_widget_textbox_lsb.value',
            shuntcal: 'widget.ti_widget_numberbox_shuntcal.value',
            truelsb: 'widget.ti_widget_textbox_truelsb.value',
            truecurrent: 'widget.ti_widget_textbox_truecurrent.value',
            requiredrange: 'widget.ti_widget_textbox_requiredrange.value'
            
        }, 'widget.ti_widget_droplist_selectedEVM.selectedIndex', function(index) {
            
        selectedEVM = templateObj.$.ti_widget_droplist_selectedEVM.selectedIndex;
        preventCalculations = true;
        window.setTimeout( () => {
            preventCalculations = false;
        }, 0);

        return { 
            sw0: data[index].sw0,
            sw1: data[index].sw1,
            adcrange: data[index].adcrange,
            rshunt: data[index].rshunt,
            maxcurrent: data[index].maxcurrent,
            currentlsb: data[index].currentlsb,
            shuntcal: data[index].shuntcal,
            truelsb: data[index].truelsb,
            truecurrent: data[index].truecurrent,
            requiredrange: data[index].requiredrange
        };
    }, function(values) {
        const index = templateObj.$.ti_widget_droplist_selectedEVM.selectedIndex;
        
        Utilities.fireEvent('select-evm', index, "settings.js");
        
        data[index] = values;
        return selectedIndex;
    });

	
	gc.databind.registry.bind('widget.ti_widget_textbox_lsb.value', 'widget.ti_widget_textbox_current.value',
     	function(value)
     	{
     	    
     	    if(isEmptyOrSpaces(value))
            {
                return templateObj.$.ti_widget_textbox_lsb.value;
            }
            
            if(preventCalculations)
            {
                return data[selectedEVM].currentlsb;  
            }
     	    
            let lsb;
            
            if(is20Bit)
            {
               lsb = value/Math.pow(2,19);
            }
            else 
            {
               lsb = value/Math.pow(2,15);
            }
           
            return lsb;
        }
	);
	
    gc.databind.registry.bind('widget.ti_widget_numberbox_shuntcal.value', 
    {
        rshunt: 'widget.ti_widget_textbox_rshunt.value',
        lsb: 'widget.ti_widget_textbox_lsb.value',
        range: 'widget.ti_widget_droplist_config_adcrange.selectedValue',
    },
     	function(values)
     	{
            let shuntCal;
            let define;
            let shunt;
            let warning = false;
            
            if(preventCalculations)
            {
                return data[selectedEVM].shuntcal;  
            }
            
            if(isEmptyOrSpaces(values.rshunt) || isEmptyOrSpaces(values.lsb))
            {
                return templateObj.$.ti_widget_numberbox_shuntcal.value;
            }
            
            shunt = values.rshunt/1000;
            
            if(is20Bit)
            {
               define = 13107200000;
            }
            else 
            {
               define = 819200000;
            }
            
            shuntCal = define * values.lsb * shunt;
            
            if (values.range === 1)
            {
               shuntCal = shuntCal * 4;
            }

            //Adjut for register limits
            shuntCal = Math.round(shuntCal);
            
            if(shuntCal > 32767)
            {
                shuntCal = 32767;
                warning = true;
            }
            
            if(shuntCal < 0)
            {
                shuntCal = 0;
                warning = true;
            }
            
            if (warning)
            {
                templateObj.$.ti_widget_numberbox_shuntcal.fontColor = "#FF0000";
                templateObj.$.ti_widget_numberbox_shuntcal.tooltip = "Calculated SHUNT_CAL, can be overwritten. Value automatically written to device. WARNING: Value limits exceeded, programmed value adjusted to be within limits.";
                templateObj.$.ti_widget_container_shuntcal.tooltip = templateObj.$.ti_widget_numberbox_shuntcal.tooltip;
            }
            else 
            {
                templateObj.$.ti_widget_numberbox_shuntcal.fontColor = "";
                templateObj.$.ti_widget_numberbox_shuntcal.tooltip = "Calculated SHUNT_CAL, can be overwritten. Value automatically written to device.";
                templateObj.$.ti_widget_container_shuntcal.tooltip = templateObj.$.ti_widget_numberbox_shuntcal.tooltip;
            }
            
            // Get a reference to the CustomCodec
            const model = document.querySelector('ti-model-register')
		    let codec = model.getCodec();
			if (!codec) {
				console.error(this.is, 'Could not get reference to codec!')
			}
			else
			{
			    codec.writeRegister(2, shuntCal, selectedEVM); 
			    codec.readRegister(2, selectedEVM);
			}
                
            // }     
            
            return shuntCal;
        }
	);
	
	gc.databind.registry.bind('widget.ti_widget_textbox_truelsb.value', 
    {
        rshunt: 'widget.ti_widget_textbox_rshunt.value',
        shuntCal: 'widget.ti_widget_numberbox_shuntcal.value',
        range: 'widget.ti_widget_droplist_config_adcrange.selectedValue',
    },
     	function(values)
     	{
            let trueLSB;
            let define;
            let shuntcal;
            let shunt;
            
            if(preventCalculations)
            {
                return data[selectedEVM].truelsb;  
            }
            
            if(isEmptyOrSpaces(values.rshunt) || isEmptyOrSpaces(values.shuntCal))
            {
                return templateObj.$.ti_widget_textbox_truelsb.value;
            }
            
            shuntcal = values.shuntCal;
            shunt = values.rshunt/1000;
            
            if(is20Bit)
            {
               define = 13107200000;
            }
            else 
            {
               define = 819200000;
            }
            
            if (values.range === 1)
            {
               shuntcal = shuntcal / 4;
            }
            
            trueLSB = shuntcal/(define*shunt)
            
            current_lsb[selectedEVM] = trueLSB;
            
            if(isNaN(current_lsb[selectedEVM]))
            {
                current_lsb[selectedEVM] = 1;
            }
            
            return trueLSB;
        }
	);

	gc.databind.registry.bind('widget.ti_widget_textbox_truecurrent.value', 
	{
	    truelsb: 'widget.ti_widget_textbox_truelsb.value',
	    rshunt: 'widget.ti_widget_textbox_rshunt.value',
	    range: 'widget.ti_widget_droplist_config_adcrange.selectedValue',
	},
     	function(values)
     	{
            let trueCurrent;
            let currentRegister;
            let shuntRegister;
            
            if(preventCalculations)
            {
                return data[selectedEVM].truecurrent;  
            }
            
            if(is20Bit)
            {
               currentRegister = values.truelsb * Math.pow(2,19);
            }
            else 
            {
               currentRegister = values.truelsb * Math.pow(2,15);
            }
            
            if (values.range === 1)
            {
                shuntRegister = 40.96/values.rshunt;
            }
            else
            {
                shuntRegister = 163.84/values.rshunt;
            }
            
            trueCurrent = Math.min(shuntRegister, currentRegister);
            
            return trueCurrent;
        }
	);
	
	gc.databind.registry.bind('widget.ti_widget_textbox_requiredrange.value', 
    {
        rshunt: 'widget.ti_widget_textbox_rshunt.value',
        current: 'widget.ti_widget_textbox_current.value',
        truecurrent: 'widget.ti_widget_textbox_truecurrent.value',
        range: 'widget.ti_widget_droplist_config_adcrange.selectedValue',
    },
     	function(values)
     	{
            let requiredRange;
            let current;
            let currentText;
            let warning = false;
            
            if(preventCalculations)
            {
                return data[selectedEVM].requiredrange;  
            }
            
            if(isEmptyOrSpaces(values.rshunt) || (isEmptyOrSpaces(values.current) && isEmptyOrSpaces(values.truecurrent)))
            {
                return templateObj.$.ti_widget_textbox_requiredrange.value;
            }
            
            if(isEmptyOrSpaces(values.current))
            {
                current = values.truecurrent;
                currentText = "true max";
            }
            else
            {
                current = values.current; 
                currentText = "max expected";
            }
            
            requiredRange = values.rshunt*current;
            
            if (values.range === 1)
            {
                if (requiredRange > 40.96)
                {
                    warning = true;
                }
            }
            else
            {
                if (requiredRange > 163.84)
                {
                    warning = true;
                }
            }
            
            if (warning)
            {
                templateObj.$.ti_widget_textbox_requiredrange.fontColor = "#FF0000";
                templateObj.$.ti_widget_textbox_requiredrange.tooltip = `Required sensing range to measure ${currentText} current with given shunt. WARNING: Required range above ADCRANGE!`;
                templateObj.$.ti_widget_container1_requiredrange.tooltip = templateObj.$.ti_widget_textbox_requiredrange.tooltip;
                templateObj.$.ti_widget_container2_requiredrange.tooltip = templateObj.$.ti_widget_textbox_requiredrange.tooltip;
            }
            else 
            {
                templateObj.$.ti_widget_textbox_requiredrange.fontColor = "";
                templateObj.$.ti_widget_textbox_requiredrange.tooltip = `Required sensing range to measure ${currentText} current with given shunt.`;
                templateObj.$.ti_widget_container1_requiredrange.tooltip = templateObj.$.ti_widget_textbox_requiredrange.tooltip;
                templateObj.$.ti_widget_container2_requiredrange.tooltip = templateObj.$.ti_widget_textbox_requiredrange.tooltip;
            }
            
            return requiredRange;
        }
	);
	
	
	// Bind register to variables
	gc.databind.registry.getBinding('widget.ti_model_register.shunt_cal_register.shunt_cal').addChangedListener(
    {
        onValueChanged: function(oldValue, newValue)
        {
            templateObj.$.ti_widget_numberbox_shuntcal.value = newValue;
     	}
    });
 	
 	gc.databind.registry.getBinding('widget.ti_model_register.config_register.adcrange').addChangedListener(
    {
        onValueChanged: function(oldValue, newValue)
        {
            adcrange[selectedEVM] = newValue;
	        templateObj.$.ti_widget_droplist_config_adcrange.selectedValue = newValue;
        }
    });

 	gc.databind.registry.getBinding('widget.ti_model_register.config_register.rst').addChangedListener(
    {
        onValueChanged: function(oldValue, newValue)
        {
     	    //read all registers from device
            const regPage = document.querySelector('ti-widget-register-page');
    		if (regPage && regPage._readAllRegistersClickHdlr) { regPage._readAllRegistersClickHdlr(); }
        }
    });
    
    //Change Listeners
    
    const swconfig = {
        onValueChanged: function() {
            //lock edit cells until switch settings are set, otherwise data may overwrite previous settings
            
            warning = false;
            
            if(templateObj.$.ti_widget_droplist_config_SW1.selectedValue === 0)
            {
                warning = true;
            }
            if(!isSPI)
            {
                if(templateObj.$.ti_widget_droplist_config_SW0.selectedValue === 0)
                {
                    warning = true;
                }
            }
            
            if(warning)
            {
                templateObj.$.ti_widget_droplist_config_adcrange.disabled = 1;
                templateObj.$.ti_widget_droplist_config_adcrange.style.backgroundColor = "#C8C8C8";
                templateObj.$.ti_widget_droplist_config_adcrange.fontColor = "#000000";
                templateObj.$.ti_widget_textbox_rshunt.disabled = 1;
                templateObj.$.ti_widget_textbox_current.disabled = 1;
                templateObj.$.ti_widget_textbox_lsb.disabled = 1;
                templateObj.$.ti_widget_numberbox_shuntcal.disabled = 1;
                templateObj.$.ti_widget_container_hardware.style.border = "1px solid red";
                templateObj.$.ti_widget_label_hw_warning.visible = true;
            }
            else
            {
                templateObj.$.ti_widget_droplist_config_adcrange.disabled = 0;
                templateObj.$.ti_widget_droplist_config_adcrange.style.backgroundColor = "#FFFFFF";
                templateObj.$.ti_widget_droplist_config_adcrange.fontColor = "#000000";
                templateObj.$.ti_widget_textbox_rshunt.disabled = 0;
                templateObj.$.ti_widget_textbox_current.disabled = 0;
                templateObj.$.ti_widget_textbox_lsb.disabled = 0;
                templateObj.$.ti_widget_numberbox_shuntcal.disabled = 0;
                templateObj.$.ti_widget_container_hardware.style.border = "1px solid black";
                templateObj.$.ti_widget_label_hw_warning.visible = false;
            }
            
        }
    };
    gc.databind.registry.getBinding('widget.ti_widget_droplist_config_SW0.selectedValue').addChangedListener(swconfig);
    gc.databind.registry.getBinding('widget.ti_widget_droplist_config_SW1.selectedValue').addChangedListener(swconfig);

});

/*
*  Boilerplate code for creating custom actions
*/
document.addEventListener('gc-nav-ready', function() 
{
    /* 
	*   Add custom actions for menu items using the following api:
	*
    *   function gc.nav.registryAction(id, runable, [isAvailable], [isVisible]);
	*
	*   param id - uniquely identifies the action, and should correspond to the action property of the menuaction widget.
	*   param runable - function that performs the custom action.
	*   param isAvailable - (optional) - function called when the menu action is about to appear.  Return false to disable the action, or true to enable it.
	*   param isVisible - (optional) - function called when the menu action is about to appear.  Return false to hide the action, or true to make it visible.
    */
	
	// For example,
	// gc.nav.registerAction('myCustomCloseAction', function() { window.close(); }, function() { return true; }, function() { return true; });
	
	// Alternatively, to programmatically disable a menu action at any time use:
	// gc.nav.disableAction('myCustomCloseAction);    then enable it again using:  gc.nav.enableAction('myCustomCloseAction'); 
});

/*
*  Boilerplate code for working with components in the application gist
*/


var initComplete = false;
//var templateObj;

// Wait for DOMContentLoaded event before trying to access the application template
var init = function() {
    templateObj = document.querySelector('#template_obj');

    // Wait for the template to fire a dom-change event to indicate that it has been 'stamped'
    // before trying to access components in the application.
	templateObj.addEventListener('dom-change',function(){
	    if (initComplete) return;
	    this.async(function(){
    	    initComplete = true;
    	    console.log("Application template has been stamped.");
  	        // Now that the template has been stamped, you can use 'automatic node finding' $ syntax to access widgets.
  	        // e.g. to access a widget with an id of 'widget_id' you can use templateObj.$.widgetId
  	        
            templateObj.$.ti_widget_numberbox_shuntcal.addEventListener("changed", function(event) {
                // Get a reference to the CustomCodec
                const model = document.querySelector('ti-model-register')
    		    let codec = model.getCodec();
    			if (!codec) {
    				console.error(this.is, 'Could not get reference to codec!')
    			}
    			else
    			{
    			    codec.writeRegister(2, templateObj.$.ti_widget_numberbox_shuntcal.value, selectedEVM);
    			    codec.readRegister(2, selectedEVM);
    			}
            });
            
            templateObj.$.ti_widget_droplist_config_SW0.addEventListener("selected", function(event) {
                if(selectedEVM === 0)
                {
                    templateObj.$.ti_widget_droplist_E1_SW0.selectedValue = templateObj.$.ti_widget_droplist_config_SW0.selectedValue;
                }
                else if(selectedEVM === 1)
                {
                    templateObj.$.ti_widget_droplist_E2_SW0.selectedValue = templateObj.$.ti_widget_droplist_config_SW0.selectedValue;
                }
                else if(selectedEVM === 2)
                {
                    templateObj.$.ti_widget_droplist_E3_SW0.selectedValue = templateObj.$.ti_widget_droplist_config_SW0.selectedValue;
                }
                else if(selectedEVM === 3)
                {
                    templateObj.$.ti_widget_droplist_E4_SW0.selectedValue = templateObj.$.ti_widget_droplist_config_SW0.selectedValue;
                }
                else
                {
                    //do nothing
                }
            });
            
            templateObj.$.ti_widget_droplist_config_SW1.addEventListener("selected", function(event) {
                if(selectedEVM === 0)
                {
                    templateObj.$.ti_widget_droplist_E1_SW1.selectedValue = templateObj.$.ti_widget_droplist_config_SW1.selectedValue;
                }
                else if(selectedEVM === 1)
                {
                    templateObj.$.ti_widget_droplist_E2_SW1.selectedValue = templateObj.$.ti_widget_droplist_config_SW1.selectedValue;
                }
                else if(selectedEVM === 2)
                {
                    templateObj.$.ti_widget_droplist_E3_SW1.selectedValue = templateObj.$.ti_widget_droplist_config_SW1.selectedValue;
                }
                else if(selectedEVM === 3)
                {
                    templateObj.$.ti_widget_droplist_E4_SW1.selectedValue = templateObj.$.ti_widget_droplist_config_SW1.selectedValue;
                }
                else
                {
                    //do nothing
                }
            });
            
        },1);

	});
};

templateObj = document.querySelector('#template_obj');
if (templateObj) {
    init();
} else {
    document.addEventListener('DOMContentLoaded',init.bind(this))
}


